#!/bin/ch
// file: animation.ch
// cgi code for displaying animation of quickreturn mech
// created: Ian Strimaitis, 5-7-2004
// modified: Matt Campbell, 11-17-2004 
#include "quickreturn.h"
#include <string.h>
#include <cgi.h>

int main()
{
   class CQuickReturn qr;
   class CRequest Request;
   class CResponse Response;
   chchar *r1, *r2, *r4, *r5, *r7, *theta1, *unit;
   double u_r1, u_r2, u_r4, u_r5, u_r7, u_theta1;
   int numpoints = 50;
   bool u_unit;

   /* get mode, SI or USC & set*/
   unit = Request.getForm("unit"); 
   if(!strcmp(unit, "USC"))
      u_unit = USC;
   if(!strcmp(unit, "SI"))
      u_unit = SI;

   /* get link lengths */
   r1 = Request.getForm("r1");
   r2 = Request.getForm("r2");
   r4 = Request.getForm("r4");
   r5 = Request.getForm("r5");
   r7 = Request.getForm("r7");

   /* get input link angle, theta2; convert later */
   theta1 = Request.getForm("theta1");

   /* set link lengths to be used in class */
   u_r1 = streval(r1);
   u_r2 = streval(r2);
   u_r4 = streval(r4);
   u_r5 = streval(r5);
   u_r7 = streval(r7);
   u_theta1 = streval(theta1);

   /* Set mechanism variables */
   qr.uscUnit(u_unit);
   qr.setNumPoints(numpoints);
   qr.setLinks(u_r1, u_r2, u_r4, u_r5, u_r7, u_theta1);

   /* Output for Web */
   Response.setContentType("application/x-qnm");
   Response.begin();
   qr.animation(QANIMATE_OUTPUTTYPE_STREAM);
   Response.end();
   return 0;
}
